# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .gcs_credential import GcsCredential

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class StorageGcs(pydantic.BaseModel):
    """
    Configuration for Google Cloud Storage for storing unstructured data

    [Configuration guide](https://docs.synqly.com/guides/provider-configuration/google-gcs-storage-setup)
    """

    bucket: str = pydantic.Field()
    """
    Name of the bucket where files are stored.
    """

    credential: GcsCredential
    region: str = pydantic.Field()
    """
    Google Cloud region where the bucket is located.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
