# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .qualys_cloud_credential import QualysCloudCredential

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class VulnerabilitiesQualysCloud(pydantic.BaseModel):
    """
    Configuration for Qualys Vulnerability Management, Detection & Response (VMDR).

    [Configuration guide](https://docs.synqly.com/guides/provider-configuration/qualys-vulns-setup)
    """

    credential: QualysCloudCredential
    url: str = pydantic.Field()
    """
    Base URL for the Qualys Cloud API.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
